#!/usr/bin/perl
#
# Poor mans cam.
# Version 1.3 Beta
#
# written by Craig Maloney
#
# This code is released under the GNU Copyleft License (GPL).
#
# This code uses code from aub (assemble usenet binaries) for the parsing
# routines. I think they're common perl routines but I want to give credit
# where credit is due.

use Net::FTP;
$flag_stamp = 0;

&config_file;

while (1) {
	if (&take_picture == 0) {
		if ($flag_stamp == 1) {
			&stamp_picture;
		}
		&ftp_picture;
	}

	if ($delete) {
		unlink "$file_directory" . "$filename" . ".jpg";
		unlink "$file_directory" . "$filename" . ".pnm";
	}

	($seconds != 0 ? sleep $seconds : &debug_output("Finished\n", 0));
}

# Configure File
sub config_file() {

open (CONFIG,"/home/craig/.pmcamrc") or die ("Can't find config file in home
directory");

# These come out of the program 'aub'. 

  foreach (<CONFIG>) {
    chop;                                       # Trim <CR>
    s/^#.*$//;                                  # Remove comments
    s/[^\\]#.*$//;
    s/\\#/#/g;          # Unescape escaped comments
    next if m/^\s*$/;                           # Skip blank lines
    s/\s+/ /;                                   # Fold white space into 1 <SP>
    s/^ //;                                     # Drop leading and trailing
    s/ $//;                                     #  white space

    ($cmd, $rest) = split(/\s+/, $_, 2);
		&parse($cmd, $rest);
	}


}

sub take_picture {
	local $outpipe;
	if ($debug == 0) { $outpipe = "2> /dev/null" } else { $outpipe = "";}
	$cam_val=(system ("($camera_command" . " " . "$camera_options" . ">" . $file_directory . $filename . ".pnm" .  " ) $outpipe"));
	if ($cam_val==0) {
		system ("$convert_command " . " $file_directory" . "$filename" . ".pnm");
	} else {
		return 1;
	}
}

sub ftp_picture {

	$ftp = Net::FTP->new("$ftp_server");
	$ftp->login("$ftp_account","$ftp_password");
	$ftp->cwd("$ftp_directory");
	$ftp->put("$file_directory" . "$filename" . ".jpg");
	$ftp->quit;

}

sub parse {
	local ($cmd, $args) = @_;

	if ($cmd =~ m/^camera_command/i) {
		$camera_command=$args;
		return;
	}

	if ($cmd =~ m/^camera_options/i) {
		$camera_options=$args;
		return;
	}
	
	if ($cmd =~ m/^filename/i) {
		$filename=$args;
		return;
	}

	if ($cmd =~ m/^file_directory/i) {
		$file_directory=$args . "/";
		return;
	}

	if ($cmd =~ m/^ftp_server/i) {
		$ftp_server=$args;
		return;
	}

	if ($cmd =~ m/^ftp_directory/i) {
		$ftp_directory=$args;
		return;
	}

	if ($cmd =~ m/^ftp_account/i) {
		$ftp_account=$args;
		return;
	}

	if ($cmd =~ m/^ftp_password/i) {
		$ftp_password=$args;
		return;
	}

	if ($cmd =~ m/^convert_command/i) {
		$convert_command=$args;
		return;
	}

	if ($cmd =~ m/^seconds/i) {
		$seconds=$args;
		return;
	}

	if ($cmd =~ m/^debug/i) {
		$debug = $args;
		return;
	}

	if ($cmd =~ m/^delete/i) {
		$delete = $args;
		return;
	}

	if ($cmd =~ m/^stamp_command/i) {
		$stamp = $args;
		$flag_stamp = 1;
		return;
	}

	if ($cmd =~ m/^stamp_top_font/i) {
		$stamp_top_font = $args;
		return;
	}

	if ($cmd =~ m/^stamp_bottom_font/i) {
		$stamp_bottom_font = $args;
		return;
	}

	if ($cmd =~ m/^stamp_top_message/i) {
		$stamp_top_message = $args;
		return;
	}

	if ($cmd =~ m/^stamp_bottom_message/i) {
		$stamp_bottom_message = $args;
		return;
	}

	if ($cmd =~ m/^stamp_gradient/i) {
		$stamp_gradient = $args;
		return;
	}
	
	if ($cmd =~ m/^stamp_options/i) {
		$stamp_options = $args;
		return;
	}
	warn "$cmd unrecognized in .pmcamrc\n";
}

sub debug_output {
	local ($a, $b) = @_;
	if ($debug == 1) {
		print "$a";
	} 
	exit ($b);
}

sub stamp_picture {
	$stamp_return = (system("$stamp -i $file_directory" .  "$filename.jpg -o $file_directory" . "$filename-stamp -y $stamp_top_font -z $stamp_bottom_font -s $stamp_gradient -u \"$stamp_top_message\" -l \"$stamp_bottom_message\" $stamp_options"));
	if ($stamp_return != 0) {
		&debug_output ('Stamp function did not exit correctly\n',1);
	}
	rename "$file_directory"."$filename-stamp","$file_directory"."$filename" . ".jpg";
}
